#include<bits/stdc++.h>
using namespace std;

int s,n,a[2005],p[2005],mig,h[20005];

int f(int g){
    mig=a[n-1]+1;
    if(g==0){
        return 0;
    }
    if(h[g]==0){
        for(int j=0;j<n;j++){
            if(g-a[j]>=0){
                mig=min(mig,f(g-a[j]));
            }
        }
        h[g]=mig+1;
        return mig+1;
    }else{
        return h[g];
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>s>>n;
    for(int i=0;i<n;i++){
        cin>>a[i];
    }
    sort(a,a+n);
    cout<<f(s)<<endl;

    return 0;
}
